## Changelog

* 1.11.1- 2014-08-07:
    * Fix: Proper selecting of shipping rate.
    * Fix: Proper grouped and variable product price displaying.
    * Fix: Removing price from products is now available again.
    * Improved: Ability to set when messages and error disappear.
* 1.11 - 2014-08-06:
    * New: Compatibility with WooThemes themes.
    * New: Check for PHP accelerators as they might cause problems.
    * New: Support for variable products in Price Filter widget.
    * New: `jigoshop_report_widgets` action to add custom report boxes.
    * New: `jQuery.payment()` function to ease payment redirection.
    * New: Ability to always select "All of" in country dropdown.
    * New: Replaced old ThickBox with WordPress Media Gallery.
    * Improved: "Edit Product Category" and "Edit Product Tag" admin bar links now works properly.
    * Improved: Better message and error disappearing times.
    * Fix: Invalid formatting of shipping dropdown.
    * Fix: Displaying multiple select fields.
    * Fix: Properly calculate tax for shipping.
    * Fix: Licence validator now checks if plugin URL is correct.
* 1.10.6 - 2014-07-30:
    * Fix: Security issue on comments feed.
    * Fix: Add obeying validate postcode setting in JavaScript validation.
    * Fix: Validating of GB postcodes.
    * Fix: Properly check EU VAT for billing country.
* 1.10.5 - 2014-07-28:
    * Fix: States changing in Edit Address and Cart pages.
    * Fix: Small typo in `my_account` shortcode template when user is not logged in.
    * Fix: Page jumping when messages are shown.
    * Improved: Jigoshop widgets reformatting.
    * Improved: Add ability to Jigoshop widgets to work together (i.e. Price Filter and Search).
* 1.10.4 - 2014-07-24:
    * Improved: Reformat and fix states changing script.
    * Improved: Ability to check if current page is payment confirmation, "Thank you" and "My account" page.
    * Improved: Edit address shortcode now has back button.
    * Improved: Shortened and simplified JavaScript for checkout.
    * Fix: Postcode validation.
    * Fix: After address save page renders properly. Thanks to Jeff Grossman
    * Fix: Product Categories widget properly handles showing counts option.
* 1.10.3 - 2014-07-21:
    * Fix: Memory checking typo.
    * Fix: Stock status checking for products.
    * Fix: PHP pre-5.3 main file compatible (for proper PHP version checking).
    * Fix: Invalid shortcode attribute managing in add to cart shortcode (thanks to Josh Virkler).
    * Improved: Memory checking error message is just a warning.
* 1.10.2 - 2014-07-21:
    * Fix: Memory check is not a fatal error anymore - plugin will continue to work.
    * Fix: As memory is not a fatal error - required memory is downgraded to 64 MB.
* 1.10.1 - 2014-07-21:
    * Fix: Memory checking for some users. Thanks to freyaluna for finding it.
* 1.10 - 2014-07-21:
    * New: `jigoshop_countries::get_countries()` function - returns alphabetically sorted list of translated country names.
    * New: `jigoshop_countries::has_country()` and `jigoshop_countries::has_state()` methods introduced.
    * New: `jigoshop_render()` and `jigoshop_render_result()` functions - easy templates rendering.
    * New: `jigoshop_product_list` shortcode.
    * New: Check for minimum, required PHP version.
    * New: Check for minimum, required WordPress version.
    * New: Check for minimum, required memory size - currently 128 MB.
    * New: Support and Docs links in Plugins list.
    * New: Ability to define default customer country.
    * New: Introduce Jigoshop menu to WordPress admin toolbar.
    * New: `jigoshop_remove_script()` function and its support in JWOS.
    * New: Provinces for Poland and Philippines. Thanks to Kristoffer Cheng
    * New: `JIGOSHOP_URL` constant - for easy access to Jigoshop files from other plugins.
    * New: `jigoshop_is_minimum_version()` function - for checking if Jigoshop matches at least specified version using `version_compare()` PHP function.
    * New: `jigoshop_add_required_version_notice()`function - for adding preformatted notice when plugin requires higher version of Jigoshop.
    * Improved: JWOS now supports PHP 5.3 with `short_open_tag` disabled.
    * Improved: Reformatted main Jigoshop file.
    * Improved: Proper variation price sanitization.
    * Improved: Removed use of deprecated methods from Jigoshop cart, introduced payment methods template.
    * Improved: Extracted account templates from shortcodes - now users can override them in their templates!
    * Improved: PayPal decimal errors for HUF, JPN and TWD currencies. Thanks to newash
    * Improved: Default look of checkout form.
    * Improved: "Tel" and "County" are now "Phone" and "Province" in admin panel.
    * Improved: Updating order status is at the end of saving the order. Thanks to newash
    * Improved: Admin settings uses JWOS now.
    * Improved: Jigoshop class information functions returns values from constants as they should.
    * Improved: Reformatted WorldPay gateway class.
    * Improved: New Google Analytics code using Universal Analytics. Thanks to Ragnar Karlsson for a tip!
    * Fix: Warning when saving product meta.
    * Fix: Removed Wordpress TwentyFourteen theme fix as it causes problems with real shops.
    * Fix: HTTPS warnings for external fonts removed.
    * Fix: Strict standards warning on edit address page.
    * Fix: Reports chart properly scales Y-Axis ticks.
* 1.9.6 - 2014-06-11:
    * New: Add version constant to `jigoshop` class for easy checking in plugins.
    * New: Javascript triggers `jigoshop.update_checkout` on body element when `update_checkout()` method is called. Useful for payment gateways.
    * Fix: Properly convert asset URLs to directory paths in JWOS.
    * Fix: Tax warnings when country is with states and no taxes are available for it.
    * Fix: Properly include ThickBox for uploads.
    * Fix: Taxes are applied to billing country instead of shipping country if product is shippable.
    * Fix: Checking if specific countries are set properly before updating tax classes.
    * Improved: Jigoshop styles on TwentyFourteen.
    * Improved: Better recognition of SSL usage.
    * Improved: Better recognition of available country and state on checkout.
    * Improved: Review order template fixes.
    * Improved: Jigoshop Countries class - now it has `get_country($country_code)` and `get_state($country_code, $state_code)` functions.
    * Improved: Check if there is shipping and payment method before displaying it in orders list.
    * Improved: Reformat of PayPal Standard gateway.
    * Improved: Introduced `JIGOSHOP_VERSION` and `JIGOSHOP_DB_VERSION` (old `JIGOSHOP_VERSION`) constants - use them instead of jigoshop::jigoshop_version() function.
    * Improved: Removed deprecated qualifier on product's `get_title()` function and updated the function.
* 1.9.5 - 2014.05.28
    * Fix: Variation data disappearing in emails.
    * Fix: Saving taxes.
    * Improve: Hide infinite availability for variable products.
    * Improve: Code cleaning.
    * Improve: Update POT file for translations.
* 1.9.4 - 2014-05-26
    * New: Checking for valid variation price (with proper error message).
    * Fix: Add BlockUI JavaScript in header for proper PayPal Standard support.
    * Fix: Minor code updates to PayPal Standard gateway.
    * Fix: Saving options in specific circumstances.
    * Fix: Warnings when no tax defined.
    * Fix: Proper checking for tax state correctness. Thanks to Karl Engstrom
    * Fix: Update variation formatting to use built-in values and selections as well.
    * Improve: Minor update of PayPal gateway.
* 1.9.3.1 - 2014-05-18
    * Fix: Quick fix for invalid use of `jigoshop_get_formatted_variation()`
* 1.9.3 - 2014-05-15
    * New: "New" order status.
    * Fix: First activation warnings.
    * Fix: Taxes are calculated even when not set for base country.
    * Fix: Database version checking on PHP 5.5.
    * Fix: Ability to add taxes to single state. Thanks to elitistdogg!
    * Fix: Order email warnings.
    * Fix: Properly display variation details. Thanks to Jared Weiss!
    * Fix: `jigoshop_localize_script()` now works properly.
    * Improve: Remove lots of backwards compatibility code from Jigoshop_Options class. WARNING: Old plugins may stop working!
    * Improve: Use `jigoshop_localize_script()` in order to avoid problems with external jQuery versions.
* 1.9.2 - 2014-05-13
    * New: System Info icon.
    * Improved: Code formatting of settings and tax classes.
    * Fix: Saving multiple taxes - fixes issue where some states were not saved thus resulting in 0% tax.
    * Fix: Calculating taxes in cart and checkout
    * Fix: Properly displaying tax values when coupons are used and tax is applied after coupons.
* 1.9.1 - 2014-05-12
    * Fix: Checking for shipping and billing state and country correctness.
* 1.9 - 2014-05-12
    * New: Jigoshop Web Optimisation System - ability to combine CSS and JavaScript into a single files.
    * New: Brand new look of Jigoshop Dashboard.
    * New: API for localizing JavaScript files in order to work with Jigoshop Web Optimisation extension.
    * New: Multipart form in admin settings to use with user-defined input fields. Thanks to Andrei Neamtu
    * New: Ability to select all countries in tax class.
    * New: More detailed information about low in stock variable products.
    * New: Validating if customer shipping country and state is allowed for taxing purposes.
    * Improved: Updated "Useful links" section.
    * Improved: Load jQuery UI Sortable plugin by default.
    * Improved: Load tim of admin dashboard for shops with many items.
    * Fix: Specific countries with tax caused orders to pass without adding required tax cost. Thanks to Naomi Taylor
    * Fix: Strict standards on `attribute_label()` method in `jigoshop_product` class.
    * Fix: Licence validator now properly deactivates licences.
    * Fix: Calculating taxes is always performed.
    * Fix: `jigoshop::plugin_url()` now returns proper URL.
* 1.8.6 - 2014-04-24
    * New: Checking for product type when loading products on sale.
    * New: jQuery `jigoshop_add_variation` action after adding new variation in admin panel.
    * Fix: Password type field on Checkout. Thanks to jlalunz
    * Fix: Different user meta used for `address 2` line in checkout and `my_account` shortcode. Thanks to robselway
* 1.8.5 - 2014-04-15
    * New: Checking if widgets has titles - otherwise skipping displaying them. Thanks to Stephen Cronin
    * New: Action `jigoshop_user_edit_address` after address edition. Thanks to robselway
    * Fix: Product statuses now matches these from Google Feed.
* 1.8.4 - 2014-04-01
    * Fix: Category dropdown is now single selection. Thanks to Riccardo F
    * Fix: Closing tags in `jigoshop_customer` class are now correctly included. Thanks to robselway
* 1.8.3 - 2014-03-31
    * New: Orders in admin panel can be filtered by date
    * Tweak: Updated licences
    * Tweak: Moved country-states javascript to separate file
    * Fix: Categories widget can redirect to "All" page too
* 1.8.2 - 2014-03-28
    * New: Jigoshop manages its assets through new API `jigoshop_add_style()` and `jigoshop_add_script()`
    * Tweak: PayPal landing page will now show Credit Card entry fields by default
    * Tweak: Remove duplicated values from System Info
    * Tweak: Redirect after error while adding product into cart
    * Fix: Use calculated order price when using PayPal Standard gateway
    * Fix: Force 0.01 charge on free orders at PayPal to allow it to process through PayPal
    * Fix: Jigoshop categories widget will again use a pop-up select when 'dropdown' setting is enabled
    * Fix: Resolve problems with Ukrainian translation
    * Languages: New Chinese Taiwan translation courtesy of Eason Chen
    * Languages: Updated Danish translation courtesy of Tine Kristensen
    * Languages: Updated German translation courtesy of Andy Jordan
    * Languages: Updated Polish translation courtesy of OptArt
* 1.8.1 - 2014-01-03
    * Tweak: Variations that are all priced the same will no longer show the secondary price when selected
    * Tweak: Free Shipping module only activates on totals after applied coupon amounts
    * Tweak: Provide total quantity products sold for Reports
    * Fix: Reports include orders from beginning day of date range
    * Fix: After coupon removal on Cart, totals recalcualted
    * Fix: Products on sale shortcode now uses default loop-shop template to allow pagination
    * Fix: Products on sale shortcode won't show all products if non actually on sale
    * Fix: Clicks on Checkout's 'ship to billing' will force a recalc for selected states and taxes
    * Fix: Numerous fixes for PHP Strict warnings
    * Languages: Updated pot file for translators
    * Languages: Updated Ukranian translation courtesy of Anatolii Sakhnik
    * Languages: Updated Croatian translation courtesy of Ivica Delic
    * Languages: Updated German translation courtesy of Andy Jordan
    * Languages: New Slovenian translation courtesy of David Bratuša
* 1.8 - 2013-10-10
    * New: WorldPay payment gateway added to Jigoshop core
    * New: Settings->General->Complete processing Orders option for `processing` orders older than 30 days
    * New: Implement Jigoshop Request API for extensions and gateways
    * New: Javascript Checkout field validation to enhance payment conversion. Shows correct and incorrect fields.
        * Orders won't be placed until all Checkout fields required data are input and validated
    * Tweak: Revamped all Jigoshop frontend javascript for modularity and efficiency
        * all Jigoshop javascript loads in footer for improved performance
    * Tweak: Updated several external javascript libraries (jQuery blockUI, select2)
    * Tweak: Removed large jQuery UI library from front end loading, loads required bits as needed (Price Filter)
    * Tweak: Jigoshop now only loads one CSS file from all internal sources for efficiency
    * Tweak: Add a codeblock option type in the settings for extensions to use internally
    * Tweak: Combine Edit Order variation attributes with product addons extension in one panel for Orders
    * Tweak: Add some filters for Jigoshop WPML extension to allow more translated items
    * Tweak: Jigoshop Reports pie chart cleanup with separate legend that won't over write charts
    * Tweak: Jigoshop Reports pie chart products now show with 5% share
    * Fix: Jigoshop Reports pie chart for 'Most Sold' per period now accurately reflects top products sold
    * Fix: Repair Google Analytics function for tracking code to load in header where it's required
    * Fix: Repair Google eCommerce Product tracking for Thank You page
    * Fix: Unpaid 'on-hold' orders from cash or cheque gateways will no longer be overwritten with another order
    * Fix: FuturePay gateway will not be selectable on the Checkout for Orders over $500.00 (current credit limit)
    * Fix: Test to ensure PayPal payment amounts and addresses matches initially submitted order as a security check
    * Fix: Remove filter that was overriding Contact Form 7 or other mail extensions for 'From' name on emails
    * Fix: Variations that use Parent Product for stock tracking, Parent will now reduce stock upon order payment
    * Languages: Updated .pot file for translators
    * Languages: Updated Brazilian translation courtesy of Raphael Suzuki
    * Languages: Updated Czech translation courtesy of Jaroslav Ondra
